Package net.sf.saxon.xpath

## Class XPathFunctionCall

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.FunctionCall
    - - net.sf.saxon.xpath.XPathFunctionCall

- All Implemented Interfaces:
    `Callable`, `ExportAgent`, `Locatable`, `IdentityComparable`, `Traceable`

      public class XPathFunctionCall
      extends FunctionCall
      implements Callable

  This class is an expression that calls an external function supplied using the JAXP XPathFunction interface

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, MAX_COST, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, UPDATE_METHOD, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `XPathFunctionCall​(StructuredQName name, javax.xml.xpath.XPathFunction function)` | Default constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `PathMap.PathMapNodeSet` | `addToPathMap​(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` | Add a representation of this expression to a PathMap.
    `Sequence` | `call​(XPathContext context, Sequence[] argValues)` | Call an extension function previously identified using the bind() method.
    `int` | `computeCardinality()` | Determine the cardinality of the result
    `Expression` | `copy​(RebindingMap rebindings)` | Copy an expression.
    `StructuredQName` | `getFunctionName()` | Get the qualified name of the function being called
    `int` | `getIntrinsicDependencies()` | Determine which aspects of the context the expression depends on.
    `ItemType` | `getItemType()` | Determine the data type of the expression, if possible.
    `Function` | `getTargetFunction​(XPathContext context)` | Get the target function to be called
    `SequenceIterator` | `iterate​(XPathContext context)` | Evaluate the function.
    `Expression` | `preEvaluate​(ExpressionVisitor visitor)` | preEvaluate: this method suppresses compile-time evaluation by doing nothing (because the external function might have side-effects and might use the context)

    - ### Methods inherited from class net.sf.saxon.expr.FunctionCall

      `addExternalFunctionCallToPathMap, adjustRequiredType, checkArgumentCount, checkArguments, checkFunctionCall, computeHashCode, equals, evaluateArguments, export, getArg, getArguments, getArity, getDisplayName, getExpressionName, getImplementationMethod, getNetCost, getOperanda, operands, optimize, pluralArguments, preEvaluateIfConstant, setArg, setArguments, setOperanda, setOperanda, simplifyArguments, toShortString, toString, typeCheck`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `adoptChildExpression, allowExtractingCommonSubexpressions, checkedOperands, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeSpecialProperties, computeStaticProperties, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, evaluatePendingUpdates, explain, getCardinality, getConfiguration, getCost, getDependencies, getEvaluationMethod, getExtraProperty, getIntegerBounds, getInterpretedExpression, getLocalRetainedStaticContext, getLocation, getObjectName, getPackageData, getParentExpression, getProperties, getProperty, getRetainedStaticContext, getScopingExpression, getSlotsUsed, getSpecialProperties, getStaticBaseURI, getStaticBaseURIString, getStaticType, getStaticUType, getStreamerName, getTracingTag, hasCompatibleStaticContext, hashCode, hasSpecialProperty, hasVariableBinding, identityHashCode, implementsStaticTypeCheck, isCallOn, isEqual, isIdentical, isInstruction, isLiftable, isMultiThreaded, isStaticPropertiesKnown, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, markTailFunctionCalls, operandList, operandSparseList, optimizeChildren, prepareForStreaming, process, resetLocalStaticProperties, restoreParentPointers, setEvaluationMethod, setExtraProperty, setFiltered, setFlattened, setLocation, setParentExpression, setRetainedStaticContext, setRetainedStaticContextLocally, setRetainedStaticContextThoroughly, setStaticProperty, simplify, simplifyChildren, staticTypeCheck, suppressValidation, toPattern, typeCheckChildren, typeError, unordered, verifyParentPointers`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.trace.Traceable

      `gatherProperties`

- - ### Constructor Detail

    - #### XPathFunctionCall

          public XPathFunctionCall​(StructuredQName name,
                                   javax.xml.xpath.XPathFunction function)

      Default constructor

  - ### Method Detail

    - #### getFunctionName

          public StructuredQName getFunctionName()

      Get the qualified name of the function being called
      Specified by:
        `getFunctionName` in class `FunctionCall`
      Returns:
        the qualified name

    - #### getTargetFunction

          public Function getTargetFunction​(XPathContext context)

      Get the target function to be called
      Specified by:
        `getTargetFunction` in class `FunctionCall`
      Parameters:
        `context` - the dynamic evaluation context
      Returns:
        always null

    - #### preEvaluate

          public Expression preEvaluate​(ExpressionVisitor visitor)

      preEvaluate: this method suppresses compile-time evaluation by doing nothing (because the external function might have side-effects and might use the context)
      Overrides:
        `preEvaluate` in class `FunctionCall`
      Parameters:
        `visitor` - an expression visitor
      Returns:
        the result of the early evaluation, or the original expression, or potentially a simplified expression

    - #### getIntrinsicDependencies

          public int getIntrinsicDependencies()

      Determine which aspects of the context the expression depends on. XPath external functions are given no access to context information so they cannot have any dependencies on it.
      Overrides:
        `getIntrinsicDependencies` in class `Expression`
      Returns:
        a set of bit-significant flags identifying the "intrinsic" dependencies. The flags are documented in class net.sf.saxon.value.StaticProperty

    - #### copy

          public Expression copy​(RebindingMap rebindings)

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Parameters:
        `rebindings` - variables that need to be re-bound
      Returns:
        the copy of the original expression

    - #### addToPathMap

          public PathMap.PathMapNodeSet addToPathMap​(PathMap pathMap,
                                                     PathMap.PathMapNodeSet pathMapNodeSet)

      Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.

      The default implementation of this method assumes that an expression does no navigation other than the navigation done by evaluating its subexpressions, and that the subexpressions are evaluated in the same context as the containing expression. The method must be overridden for any expression where these assumptions do not hold. For example, implementations exist for AxisExpression, ParentExpression, and RootExpression (because they perform navigation), and for the doc(), document(), and collection() functions because they create a new navigation root. Implementations also exist for PathExpression and FilterExpression because they have subexpressions that are evaluated in a different context from the calling expression.

      Overrides:
        `addToPathMap` in class `Expression`
      Parameters:
        `pathMap` - the PathMap to which the expression should be added
        `pathMapNodeSet` -
      Returns:
        the pathMapNode representing the focus established by this expression, in the case where this expression is the first operand of a path expression or filter expression. For an expression that does navigation, it represents the end of the arc in the path map that describes the navigation route. For other expressions, it is the same as the input pathMapNode.

    - #### iterate

          public SequenceIterator iterate​(XPathContext context)
                                   throws XPathException

      Evaluate the function.
      Overrides:
        `iterate` in class `FunctionCall`
      Parameters:
        `context` - The context in which the function is to be evaluated
      Returns:
        a Value representing the result of the function.
      Throws:
        `XPathException` - if the function cannot be evaluated.

    - #### call

          public Sequence call​(XPathContext context,
                               Sequence[] argValues)
                        throws XPathException

      Call an extension function previously identified using the bind() method. A subclass can override this method.
      Specified by:
        `call` in interface `Callable`
      Parameters:
        `context` - The XPath dynamic context
        `argValues` - The values of the arguments
      Returns:
        The value returned by the extension function
      Throws:
        `XPathException` - if a dynamic error occurs during the evaluation of the expression

    - #### getItemType

          public ItemType getItemType()

      Determine the data type of the expression, if possible. All expressions return sequences, in general; this method determines the type of the items within the sequence, assuming that (a) this is known in advance, and (b) it is the same for all items in the sequence.

      This method will always return a result, though it may be the best approximation that is available at the time.

      Specified by:
        `getItemType` in class `Expression`
      Returns:
        the item type

    - #### computeCardinality

          public int computeCardinality()

      Determine the cardinality of the result
      Specified by:
        `computeCardinality` in class `Expression`
      Returns:
        ZERO_OR_MORE (we don't know)